const tmi = require('tmi.js');
require('dotenv').config();

console.log(process.env.API_HOST);

const client = new tmi.Client({
  options: { debug: true },
  connection: {
    secure: true,
    reconnect: true
  },
  identity: {
    username: process.env.TTV_BOT_USERNAME,
    password: process.env.TTV_BOT_OAUTH
  },
  channels: [ process.env.TTV_CHANNELS ]
});

client.connect();

client.on('message', (channel, tags, message, self) => {
    if(self) return;
    const badges = tags.badges || {};
    const isBroadcaster = badges.broadcaster;
    const isMod = badges.moderator;
    const isModUp = isBroadcaster || isMod;
});
// R E A C T I V E
// ==================================
client.on("anongiftpaidupgrade", (channel, username, userstate) => {
    // Do your stuff.
    client.whisper(username, `UPGRADE COMPLETE! Thank you very much for supporting The Sarimoko Show!`);
});
client.on("ban", (channel, username, reason, userstate) => {
    // Do your stuff.
    client.say(channel, `/me bye felicia`);
});
client.on("cheer", (channel, userstate, message) => {
    // Do your stuff.
    client.say(channel, `/me Cheer test`);
});
client.on("clearchat", (channel) => {
    // Do your stuff.
    client.say(channel, `The Laws`);
    client.say(channel, `The Rule of Law`);
    client.say(channel, `1. Don't feed the Trolls!`);
});
client.on("giftpaidupgrade", (channel, username, sender, userstate) => {
    // Do your stuff.
});
client.on("hosting", (channel, target, viewers) => {
    // Do your stuff.
    client.say(channel, `/me Host Test`);
});
// User joins/connects
client.on("join", (channel, username, self) => {
    client.say(channel, `/me +1 Chatter! Viewer or Bot...? Time will tell!`);
});
// Bye Felicia!
client.on("part", (channel, username, self) => {
    client.say(channel, `/me -1 Chatter! Where's my bounty hunters?  Essemble the *air-qoutes* search-party *air-qoutes*`);
});
// Incoming Raid
client.on("raided", (channel, username, viewers) => {
    client.say(channel, `/me Welcome raiders!!! We make take your viewership, but we'll never take your FREEDOM!!!`);
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
});
client.on("subgift", (channel, username, streakMonths, recipient, methods, userstate) => {
    // Do your stuff.
    let senderCount = ~~userstate["msg-param-sender-count"];
});
client.on("submysterygift", (channel, username, numbOfSubs, methods, userstate) => {
    // Do your stuff.
    let senderCount = ~~userstate["msg-param-sender-count"];
});
client.on("resub", function (channel, username, months, message, userstate, methods) {
    // Do your stuff.
    client.say(channel, `/me Re-SUB test`);
});
client.on("subscription", function (channel, username, method, message, userstate) {
    // Do your stuff.
    client.say(channel, `/me SUB Test`);
});
client.on("whisper", (from, userstate, message, self) => {
    // Don't listen to my own messages..
    if (self) return;

    // Do your stuff.
    client.say(channel, `/me Bleep! Bloop! Sext message recieved!`);
});

// !COMMANDS
// ==================================
// TODO:
// ==================================
// + Add Cooldowns
// + Add Mod vs Streamer vs Viewer vs Sub control
// + Turn BOTO into join userchannel_db & make botoff to rm_userchannel_db
// + Timed
// + B-Day Calc
// +
// + 

client.on('message', (channel, tags, message, self) => {
  if(self || !message.startsWith('!')) return;

  const args = message.slice(1).split(' ');
  const command = args.shift().toLowerCase();
  const botUserState = client.userstate[channel];
  const amMod = botUserState !== undefined && botUserState.mod === true;

  // M O D   S Q U A D
  // ----------------------------------
  //let isMod = user.mod || user['user-type'] === 'mod';
  //let isBroadcaster = channel.slice(1) === user.username;
  //let isModUp = isMod || isBroadcaster;
  //if(isModUp) {
    // Something for moderators or higher
  //}

  // I N F O
  // ==================================
  // The Cord
  // ----------------------------------
  if(command === 'cord' || command === 'discord') {
    client.say(channel, `/me The Cord by Sarimoko is joinable & sharable at: https://cord.sarimoko.com/`);
  }
  // The Boto
  // ----------------------------------
  else if(command === 'boto' || command === 'sariboto' || command === 'sari-boto') {
    client.say(channel, `/me Bleep! Bloop! sarimoBOTO Twitch IRC connected... LETS PARTY!!!`);
    client.say(channel, `!kappagen imGlitch EarthDay imGlitch EarthDay imGlitch`);
  }
  // The Boto
  // ----------------------------------
  else if(command === 'boto' || command === 'sariboto' || command === 'sari-boto') {
    client.say(channel, `/me Bleep! Bloop! Twitch IRC connected... LETS PARTY!!!`);
    client.say(channel, `!kappagen imGlitch EarthDay imGlitch EarthDay imGlitch`);
  }
  // The Color
  // ----------------------------------
  else if(command === 'color') {
    client.say(channel, `/color ${args.join(' ')}`);
    client.say(channel, `/me Bleep! Bloop! New color is ${args.join(' ')}`);
  }
  // The Dojo
  // ----------------------------------
  else if(command === 'dojo') {
    client.say(channel, `/me Learn the methods of a madman at: https://dojo.sarimoko.com/`);
  }
  // The Echo
  // ----------------------------------
  else if(command === 'echo') {
    client.say(channel, `/me @${tags.username} says ${args.join(' ')}`);
  }
  // The Hair
  // ----------------------------------
  else if(command === 'hair' || command === 'hairflip' || command === 'bang' || command === 'headbang') {
    client.say(channel, `!kappagen sarimoBANG sarimoHAIR sarimoBANG sarimoHAIR sarimoBANG sarimoHAIR `);
  }
  // The Hugs
  // ----------------------------------
  else if(command === 'hug' || command === 'hugs') {
    client.say(channel, `/me @${tags.username} just gave ${args.join(' ')} a big'o'hug! `);
  }
  // The Kick
  // ----------------------------------
  else if(command === 'kick' || command === 'attack' || command === 'punch') {
    client.say(channel, `/me @${tags.username} just hit ${args.join(' ')}! I'm telling! `);
  }
  // The Lurk
  // ----------------------------------
  else if(command === 'lurk' || command === 'lurking' || command === 'lurkin' || command === 'brb') {
    client.say(channel, `/me Enjoy your lurk ${tags.username}, thanks for the viewership! `);
    client.say(channel, `!kappagen sarimoLURKbrb sarimoKO sarimoLURKbrb sarimoKO sarimoLURKbrb sarimoKO `);
  }
  // The Mote
  // ----------------------------------
  else if(command === 'mote' || command === 'emote' || command === 'emotes') {
    client.say(channel, `!kappagen sarimoBOTO sarimoDEAD sarimoDUDE sarimoGAME sarimoMASK sarimoGEAR sarimoHAIR sarimoHYPE sarimoLURK sarimoMILK sarimoNERD sarimoRAID sarimoSALT sarimoSOUP sarimoRIDE sarimoKO `);
    client.say(channel, `sarimoBANG sarimoFREEDOM sarimoLURKbrb sarimoSALTplz sarimoTRIP  `);
  }
  // The Sale
  // ----------------------------------
  else if(command === 'sale' || command === 'buygames' || command === 'humble' || command === 'bundle' || command === 'humblebundle') {
    client.say(channel, `Get sales & give to charity! Win + win, right?! Check out HumbleBundle, use this affiliated link to support the stream: https://www.humblebundle.com/?partner=rusttv`);
  }
  // The Wish
  // ----------------------------------
  else if(command === 'wish' || command === 'wishlist' || command === 'amazon' || command === 'gift') {
    client.say(channel, `/me First off, thank you ${tags.username} for even considering contributing directly! Amazon Wishlists have been split into sub-categories and are available at: https://wish.sarimoko.com/ `);
  }

  // T H E   V I E W E R S
  // ==================================
  // TODO Followerage
  // TODO Total Followers
  // TODO Total Channel Views
  // TODO Current Viewers
  // ----------------------------------

  // T H E   R A I D
  // ==================================
  // Being Raided
  // ----------------------------------
  //else if(command === 'raid' || command === 'raided') {
  //  client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
  //  client.say(channel, `/me Did @${tags.username} say RAID!?! I believe ${args.join(' ')}, was mentioned as well!`);
  //}
  // Raiding Someone
  // ----------------------------------
  else if(command === 'raid' || command === 'raidcall' || command === 'spam' || command === 'spamwars') {
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
    client.say(channel, `/me Thanks everyone for watching!!! PREPARE TO SPAM!`);
    client.say(channel, `/me Copy'n'Paste the following: (Yes, even if you don't have a sub... We know your a sub at PrideHeartL PrideHeartR LuvHearts`);
    client.say(channel, `sarimoRAID sarimoFREEDOM You may take us viewers, but you'll NEVER take our FREEDOM!`);
  }
  // Shoutout
  // ----------------------------------
  else if(command === 'so' || command === 'shoutout' || command === 'holla' || command === 'pimp') {
    client.say(channel, `Go checkout @${tags.username}'s channel! Hit that follow button like it owes you money!`);
  }

  // K A P P A
  // ==================================
  // FX | Bad Game
  // ----------------------------------
  else if(command === 'badgame' || command === 'anti-gg' || command === 'notgg') {
    client.say(channel, `!kappagen sarimoDEAD sarimoGAME `);
  }
  // FX | Hi
  // ----------------------------------
  else if(command === 'hi' || command === 'hello' || command === 'welcome' || command === 'greeting' || command === 'greetings') {
    client.say(channel, `!kappagen HeyGuys bleedPurple HeyGuys bleedPurple HeyGuys`);
    client.say(channel, `/me Hi Hello Howdy Hola こんにちは Oi 你好 여보세요 Здравствуйте Bonjour Hej Hiya Heyo Yo`);
  }
  // FX | Clap
  // ----------------------------------
  else if(command === 'clap' || command === 'clap' || command === 'applaude') {
    client.say(channel, `!kappagen :clap: FBCatch :clap: FBCatch :clap: `);
  }
  // FX | Sup
  // ----------------------------------
  else if(command === 'sup' || command === 'whatsup' || command === 'sups' || command === 'wazzup' || command === 'soup' || command === 'soups') {
    client.say(channel, `!kappagen sarimoTRIP sarimoSOUP sarimoTRIP sarimoSOUP sarimoTRIP sarimoSOUP `);
    client.say(channel, `/me Yo @${tags.username}, how goes it?`);
  }
  // FX | Salt
  // ----------------------------------
  else if(command === 'salt' || command === 'yoho' || command === 'rage' || command === 'rip' || command === 'sassy' || command === 'salty' || command === 'bitter') {
    client.say(channel, `!kappagen PJSalt PanicVis PJSalt WutFace PJSalt PunOko PJSalt BabyRage PJSalt`);
  }

  
  // G E N E R A L
  // ==================================
  // Uptime
  // ----------------------------------
  // if(commandName === 'uptime') {
  //  let timestamp = new Date(body.stream.created_at).getTime();
  //  uptime = countdown(timestamp, Date.now(), 158);
  //  reply(uptime);
  //}

  // The 2Pac Timezone
  // ----------------------------------
  //else if(command === '2pac' || command === 'pst' || command === 'timezone') {
  //  client.say(channel, `/me Off in the distance @${tags.username} screams...`);
  //  client.say(channel, `" ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} " can be heard to all those around!`);
  //}
  
  // Backend
  // ----------------------------------
  //else if(command === 'ad' || command === 'ads' || command === 'dab30' || command === 'intermission') {
  //  client.say(channel, `Bleep! Bloop! Sub to bypass ads! `);
  //  client.commercial("channel", 30)
  //  .then((data) => {
  //      // data returns [channel, seconds]
  //  }).catch((err) => {
  //      //
  //  });
  }
  
  // E R R O R S
  // ==================================
  // NOT FOUND FUNCTION
  else {
    client.say(channel, `/me Bleep! Bloop! Error! Sorry, @${tags.username} hopefully SE/SL/Nitebot has ya covered...`);
  }
});
